<template>
    <!-- Box (User Not Logged In) -->
    <v-row class="pl-16 pr-16 box">
        <!-- Authorize access to box -->
        <v-col v-if="authorize" cols="10">
            <v-row>
                <!-- Back Button -->
                <v-col cols="12">
                    <v-btn icon text class="pa-0 text-left">
                        <v-icon>mdi-arrow-left</v-icon>
                    </v-btn>
                </v-col>
                <v-col cols="5" class="mr-10">
                    <h2>{{ $t('box.shipping') }}</h2>
                    <p>{{ $t('box.freeDoorToDoor') }}</p>

                    <v-select
                        :items="dates"
                        placeholder="Select your preferred date"
                    ></v-select>

                    <v-select
                        :items="times"
                        placeholder="Select your preferred time"
                    ></v-select>
                </v-col>
                <v-col cols="5">
                    <h2>{{ $t('box.payment') }}</h2>
                    <p>{{ $t('box.total') }} {{ total }}</p>
                    <p class="mt-3">Credit Card</p>
                    <!-- CREDIT CARD NUMBER -->
                    <v-text-field
                        ref="cc"
                        v-model="form2.cc.value"
                        v-mask="'#### #### #### ####'"
                        :rules="[requiredRules]"
                        name="input-10-2"
                        :label="$t('form.cc.text')"
                        :placeholder="$t('form.cc.placeholder')"
                        class="input-group--focused"
                        solo
                        @click:append="showPass = !showPass"
                        ><template slot="append">
                            <img
                                :src="visa"
                                width="51"
                                height="17"
                                class="mr-2"
                            />
                            <img
                                :src="master"
                                width="35"
                                height="19"
                            /> </template
                    ></v-text-field>

                    <v-row>
                        <!-- EXPIRY DATE -->
                        <v-col cols="6">
                            <v-text-field
                                ref="expiryDate"
                                v-model="form2.expiryDate.value"
                                v-mask="'##/##'"
                                :label="$t('form.expiryDate.text')"
                                :placeholder="$t('form.expiryDate.placeholder')"
                                solo
                                :rules="[requiredRules]"
                            ></v-text-field>
                        </v-col>
                        <!-- CVV -->
                        <v-col cols="6">
                            <v-tooltip v-model="showCVV" top>
                                <template
                                    v-slot:activator="{
                                        on,
                                    }"
                                >
                                    <v-text-field
                                        ref="cvv"
                                        v-model="form2.cvv.value"
                                        v-mask="'###'"
                                        :label="$t('form.cvv.text')"
                                        :placeholder="
                                            $t('form.cvv.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules, requiredCVV]"
                                        append-icon="mdi-information-outline"
                                        @click:append="showCVV = !showCVV"
                                    ></v-text-field>
                                </template>
                                <span>{{ $t('form.cvv.hint') }} </span>
                            </v-tooltip>
                        </v-col>
                    </v-row>
                </v-col>
                <v-col cols="5" class="mr-10"> </v-col>

                <v-col cols="5" class="text-right">
                    <v-btn
                        class=" lowercase br-0 pl-10 pr-10 font-syne-bold"
                        color="badge"
                        @click="submit"
                        >{{ $t('box.proceedToPayment') }}</v-btn
                    >
                </v-col>
            </v-row>
        </v-col>

        <!-- Unauthorize access to box -->
        <v-col v-else cols="10">
            <v-row>
                <!-- Back Button -->
                <v-col cols="2">
                    <v-btn icon text class="pa-0 text-left">
                        <v-icon>mdi-arrow-left</v-icon>
                    </v-btn>
                </v-col>

                <!-- New to hype2u -->
                <v-col cols="10" class="text-right">
                    <v-btn class="lowercase" text>{{
                        $t('box.newToHype2u')
                    }}</v-btn>
                    <v-btn text color="badge" class="lowercase pl-0">{{
                        $t('box.signUpNow')
                    }}</v-btn>
                </v-col>

                <!-- Title -->
                <v-col cols="12" class="pl-5">
                    <h2>
                        {{ $t('common.signIn') }}
                    </h2>
                </v-col>

                <!-- Email -->
                <v-col cols="5" class="mr-10">
                    <!-- EMAIL -->
                    <v-text-field
                        ref="email"
                        v-model="form.email.value"
                        :label="$t('form.email.text')"
                        :placeholder="$t('form.email.placeholder')"
                        solo
                        :rules="[requiredRules, requiredEmail]"
                        :error-messages="form.email.error"
                    ></v-text-field>

                    <!-- Remember Me Checkbox -->
                    <v-checkbox
                        ref="terms"
                        v-model="checkbox"
                        color="grey"
                        background-color="transparent"
                        :rules="[requiredRules]"
                        required
                        class="ma-0"
                        off-icon="mdi-checkbox-blank-circle-outline"
                        on-icon="mdi-checkbox-marked-circle-outline"
                    >
                        <template v-slot:label>
                            <div
                                class="font12 highlight-white-text"
                                @click.stop=""
                            >
                                {{ $t('box.rememberMe') }}
                            </div>
                        </template>
                    </v-checkbox>
                </v-col>

                <!-- Password -->
                <v-col cols="5">
                    <v-text-field
                        ref="password"
                        v-model="form.password.value"
                        :append-icon="showPass ? 'mdi-eye' : 'mdi-eye-off'"
                        :rules="[requiredRules, requiredMin]"
                        :type="showPass ? 'text' : 'password'"
                        name="input-10-2"
                        :label="$t('form.password.text')"
                        :placeholder="$t('form.password.placeholder')"
                        :hint="$t('form.password.min')"
                        class="input-group--focused"
                        solo
                        @click:append="showPass = !showPass"
                    ></v-text-field>

                    <!-- Forget Password -->
                    <v-btn text color="badge" class="lowercase ma-0 pa-0">{{
                        $t('common.forgetPassword')
                    }}</v-btn>
                </v-col>

                <!-- Login Button -->
                <v-col cols="12" class="align">
                    <v-btn
                        class="mt-5 lowercase br-0 pl-10 pr-10 font-syne-bold"
                        color="badge"
                        @click="submit"
                        >{{ $t('common.signIn') }}</v-btn
                    >
                </v-col>
            </v-row>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
const { VueMaskDirective } = require('v-mask')

Vue.directive('mask', VueMaskDirective)
@Component
export default class Box extends Vue {
    // Data
    dates: any = ['26/10/2020', '27/10/2020']
    times: any = ['10:00 AM', '11:00 AM']
    authorize: Boolean = true
    showPass: Boolean = false
    showCVV: Boolean = false
    formHasErrors: Boolean = false
    total: Number = 0
    form: { [key: string]: any } = {
        email: {
            value: '',
            error: null,
            requestKey: 'email',
        },
        password: {
            value: '',
            error: null,
            requestKey: 'password',
        },
    }

    form2: { [key: string]: any } = {
        name: {
            value: '',
            error: null,
            requestKey: 'last_name',
        },
        cc: {
            value: '',
            error: null,
            requestKey: 'cc',
        },
        expiryDate: {
            value: '',
            error: null,
            requestKey: 'expiry_date',
        },
        cvv: {
            value: '',
            error: null,
            requestKey: 'cvv',
        },
    }

    visa: String = require('~/assets/images/visa.png')
    master: String = require('~/assets/images/mastercard.png')

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredEmail(v: string) {
        if (v) {
            if (v.length > 0) {
                const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                return (
                    pattern.test(v) || this.$t('form.validation.invalidEmail')
                )
            }
        }
        return this.$t('form.validation.required')
    }

    requiredMin(v: string) {
        if (v) {
            if (v.length >= 8) {
                return true
            }
        }
        return this.$t('form.password.min')
    }

    requiredCVV(v: string) {
        if (v) {
            if (v.length === 3) {
                return true
            }
        }
        return this.$t('form.cvv.max')
    }

    submit() {
        console.log('Login Successful')
    }
}
</script>
